/*
个人中心首页头图展示
 */
define(function(require, exports, module) {
    require('slick');
    var storage = window.localStorage;
    var utils = require('../utils');
    var reportConf = require('./report/report_conf').hottagConf;
    var normalizer = require('./urlFactory').createNormalizer();
    var ptagBuilder = require('./ptagBuilder');

    var aid = decodeURIComponent(utils.getUrlParam('aid')) || '';
    var hotTagPre = reportConf.headpic;

    function initHeadPic() {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽头图
                $('.js_mod_tips_link').hide();
            } else {
                initHeadPicCalbck();
            }
        });
    }

    function initHeadPicCalbck() {
        getHeadPic(function(data) {
            if (data.length > 0) {
                buildHeadPic(data);
                storage.setItem("app_hlw_user_headpic_roll", JSON.stringify(data));
            } else {
                if (storage.getItem("app_hlw_user_headpic_roll")) {
                    storage.removeItem("app_hlw_user_headpic_roll");
                }
            }
        }, function() {
            $('.js_mod_tips_link').hide();
        });
    }

    function getHeadPic(suCb, failCb) {
        var platform = utils.getPlatform();
        var platStr = "iphone";
        if (platform == 8) {
            platStr = "aphone"
        }
        $.ajax({
            //url: normalizer('http://mobile.video.qq.com/fcgi-bin/dout_iphone?otype=json&auto_id=1317&platform=7&version=0'),
            url: normalizer('//node.video.qq.com/x/vip/api/common?_m=vipActicity.getHeadpic("'+platStr+'")'),
            dataType: "jsonp",
            success: function(json) {
                if (!json || json.ret !== 0 || !json.data || !json.data.vipActicity || !json.data.vipActicity.headpic) {
                    failCb && failCb();
                } else {
                    suCb && suCb(json.data.vipActicity.headpic);
                }

            },
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                failCb && failCb();
            }
        });
    }

    function _getPtagAdd() {
        var ptagAdd = "ad.kttop.apho";
        if (utils.isIosPf()) {
            ptagAdd = "ad.kttop.ipho";
        }
        return ptagAdd;
    }

    function buildHeadPic(items) {
        _renderHeadPicItems(items);
        if (items.length > 1) {
            var $headpic = $('.js_tips_link');
            if ($headpic.hasClass('slick-initialized')) {
                $headpic.slick('unslick');
            }
            $headpic.slick({
                speed: 300,
                arrows: false,
                autoplay: true,
                draggable: false,
                autoplaySpeed: 5000,
                initialSlide: 0,
                vertical: true
            });
        }

    }

    function _renderHeadPicItems(items) {
        var ul_dom = $('.js_tips_link');
        var ul_dom_swap = $('.js_tips_link_swap');
        var lis_dom = '';
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            var url = ptagBuilder.addPtag(item.url, _getPtagAdd());
            var hottag = hotTagPre + "_" + _getPtagAdd();
            var ptag = utils.getUrlParam2(url, 'ptag');
            var tpl = '<li data-url="' + normalizer(url) + '" hottag="' + hottag + '" f_pagetag="' + ptag + '">' +
                '<a class="tips_link cf" href="javascript:;">' +
                '<span class="tips_pic">' +
                '<img src="' + normalizer(item.icon_url) + '" alt=" ">' +
                '</span>' +
                '<span class="tips_txt">' + item.banner_txt + '</span>' +
                '<i class="icon_arrow"></i>' +
                '</a></li>';
            lis_dom += tpl;
        };
        if (lis_dom.length > 0) {
            ul_dom.html(lis_dom);
            $('.js_mod_tips_link').show();
        }
    }

    exports.init = initHeadPic;
});
