/*
ios审核期间套餐
 */
define(function(require, exports, module) {
    var utils = require('../utils');
    var reportConf_hottag = require('./report/report_conf').hottagConf;

    function initPriceList(isVip) {
        if (utils.isIosPf()) {
            utils.isInreviewVer(function(vertype) {
                if (vertype == "1") {
                    try {
                        $.getJSON("./js/price_check_version.json", function(data) {
                            _renderPriceList(data.price_list, isVip);

                        });                        
                    } catch (ex) {}
                } else {
                    $('.js_inreview_price').hide();
                }

            });
        } else {
            $('.js_inreview_price').hide();
        }
    }

    function _renderPriceList(data, isVip) {
        var tpl = '';
        var openHint = "开通";
        if (isVip) {
            openHint = "续费";
        }
        
        for (var i = 0, l = data.length; i < l; i++) {
            var item = data[i];
            var hotTagPay = [reportConf_hottag.openPay_hvipMonth, "_", item.amount].join('');
            var _f_resource = "";
            if (item.product_desc && item.product_desc.length > 0) {
                _f_resource = item.product_desc;
            }
            tpl += '<li class="list_item js_inreview_pitem">';
            tpl += '<div class="txt_info">';
            tpl += '<span class="txt">' + item.product_desc + '<span class="num">' + item.price + '</span>元</span>';
            if (item.icon_desc) {
                tpl += '<span class="mark_flag">' + item.icon_desc + '</span>';
            }
            tpl += '</div>';
            tpl += '<a class="link_info js_inreview_pay" href="javascript:;" title="开通" data-amount="' + item.amount + '" data-id="' + item.product_id + '" data-month-price="' + item.price + '" data-pay-type="' + item.type + '"  data-single-price="' + item.single_price + '" hottag="' + hotTagPay + '" f_resource="' + _f_resource + '"><span class="txt">' + openHint + '</span></a>';
            tpl += '</li>';
        }
        if (tpl.length > 0) {
            var $priceDom = $('.js_inreview_price').find('.js_inreview_pitem');
            if ($priceDom.length > 0) {
                $('.js_inreview_pay .txt').html(openHint);
            } else {
                $(".js_inreview_price").append(tpl);
                $(".js_inreview_price").show();

                $(document).undelegate(".js_inreview_pay", "click").delegate('.js_inreview_pay', 'click', function(event) {
                    var param = {
                        month: $(this).attr('data-amount'),
                        id: $(this).attr('data-id'),
                        product_price: $(this).attr('data-month-price'),
                        product_single_price: $(this).attr('data-single-price'),
                        product_type: $(this).attr('data-pay-type'),
                        hottag: $(this).attr('hottag'),
                        f_resource: $(this).attr('f_resource')
                    };
                    utils.tenvideoReady(function() {
                        TenvideoJSBridge.invoke("openPay", param, function(json_msg) {
                            var json = JSON.parse(json_msg);
                            if (json.errCode == 0) {} else {}
                        });
                    });

                });
            }
        }
    }

    module.exports = {
        init: initPriceList
    }
});
