/*
个人中心我的资产红点提示
 */
define(function(require, exports, module) {
    var normalizer = require('./urlFactory').createNormalizer();
    var isRedPointShow = false;

    function _redpointReqAjax() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name=spp_red_touch&cmd=1&otype=json&red_touch_id_list=10007'),
            dataType: 'jsonp'
        }).done(function(res) {
            if (res && res.ret == 0) {
                $defer.resolve(res);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function _redpointDelAjax() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name=spp_red_touch&cmd=2&otype=json&red_touch_id_list=10007'),
            dataType: 'jsonp'
        }).done(function(res) {
            if (res && res.ret == 0) {
                $defer.resolve(res);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function init() {
        _redpointReqAjax().done(function(json) {
            if (json && json.red_list && json.red_list.length > 0) {
                var redlist = json.red_list;
                var has_red_point = false;
                for (var i = 0; i < redlist.length; i++) {
                    var item = redlist[i];
                    if (item.show_flag) {
                        has_red_point = true;
                        break;
                    }
                }
                if (has_red_point && !isRedPointShow) {
                    isRedPointShow = true;
                    $('.js_property_item .user_property').addClass("my_assets");
                } else {
                    $('.js_property_item .user_property').removeClass("my_assets");
                }
            } else {
                $('.js_property_item .user_property').removeClass("my_assets");
            }
        }).fail(function() {
            $('.js_property_item .user_property').removeClass("my_assets");
        });
    }

    function clearRedPoint() {
        hideRedPoint();
        _redpointDelAjax();
    }

    function hideRedPoint() {
        isRedPointShow = true;
        $('.js_property_item .user_property').removeClass("my_assets");
    }

    module.exports = {
        showPoint: init,
        clearRedPoint: clearRedPoint,
        hideRedPoint: hideRedPoint
    }
});
