/*
个人中心我的资产tips提示
 */
define(function(require, exports, module) {
    var normalizer = require('./urlFactory').createNormalizer(),
        propertyGrowTips = require('./ticketUp_tip'),
        eventList = {
            "10001": "礼品卡未被领完",
            "11001": "有奖品未填地址"
        },
        show_tips_tid = 0,
        tips_has_show = false,
        myPropertyRedpoint = require('./my_propery_redpoint'),
        property_jump_url = "https://film.qq.com/weixin/v3/asset/index.html?header=0",
        _eventType = "";

    function _tipsReqAjax() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name=spp_bubble&cmd=1&otype=json&bubble_id_list=10001&operate_type=1'),
            dataType: 'jsonp'
        }).done(function(res) {
            if (res && res.ret == 0) {
                $defer.resolve(res);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function _tipsDelAjax(eventType) {
        var $defer = $.Deferred();
        var url = normalizer('http://vip.video.qq.com/fcgi-bin/comm_cgi?name=spp_bubble&cmd=3&otype=json&bubble_id=10001');
        if (eventType) {
            url += "&event_type_list=" + eventType;
        }
        $.ajax({
            url: url,
            dataType: 'jsonp'
        }).done(function(res) {
            if (res && res.ret == 0) {
                $defer.resolve(res);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function init() {
        _tipsReqAjax().done(function(json) {
            if (json && json.bubble_list && json.bubble_list.length > 0) {
                var bubblelist = json.bubble_list;
                var has_bubble = false;
                var bubble = json.bubble_list[0];
                if (bubble.show_flag) {
                    has_bubble = true;
                }
                if (has_bubble && !tips_has_show) {
                    tips_has_show = true;
                    if (bubble.event_type_unit_list && bubble.event_type_unit_list.length > 0) {
                        var bubble_event = bubble.event_type_unit_list[0];
                        var eventType = bubble_event.event_type;
                        _eventType = eventType;
                        var tips = eventList[eventType];
                        if (tips) {
                            _getJumpUrl(eventType);
                            $('.js_property_item .js_user_property_tip').html(tips);
                            $('.js_property_item .js_user_property_tip').css({ "opacity": "0" });
                            $('.js_property_item .js_user_property_tip').show();
                            setTimeout(function() {
                                $('.js_property_item .js_user_property_tip').css({ "opacity": "1", "transition": "opacity 2s linear;" });
                            }, 0);
                            if (show_tips_tid == 0) {
                                show_tips_tid = setTimeout(function() {
                                    setTimeout(function() {
                                        $('.js_property_item .js_user_property_tip').css({ "opacity": "0", "transition": "opacity 1s linear;" });
                                    }, 0);
                                }, 5e3);
                            }
                        }
                    }
                } else {
                    $('.js_property_item .js_user_property_tip').hide();
                    _getJumpUrl();
                    myPropertyRedpoint.showPoint();
                    propertyGrowTips.init();
                }
            } else {
                $('.js_property_item .js_user_property_tip').hide();
                _getJumpUrl();
                myPropertyRedpoint.showPoint();
                propertyGrowTips.init();
            }
        }).fail(function() {
            $('.js_property_item .js_user_property_tip').hide();
            _getJumpUrl();
            myPropertyRedpoint.showPoint();
            propertyGrowTips.init();
        });
    }

    function clearShowTipsId() {
        show_tips_tid = 0;
        propertyGrowTips.clearTicketShow();
    }

    function clearMyProperTips() {
        //消除红点
        myPropertyRedpoint.hideRedPoint();
        if (_eventType) {
            _getJumpUrl(_eventType);
            _tipsDelAjax(_eventType).done(function(res) {
                _eventType = "";
            });
        } else {
            myPropertyRedpoint.clearRedPoint();
            _getJumpUrl();
        }
    }

    function _getJumpUrl(eventType) {
        eventType = eventType || "";
        if ("10001" == eventType) {
            property_jump_url += "&tab=gift_card";
        } else if ("11001" == eventType) {
            property_jump_url += "&tab=award";
        } else {
            property_jump_url = "https://film.qq.com/weixin/v3/asset/index.html?header=0";
        }
    }

    module.exports = {
        showTips: init,
        clearPropertyShow: clearShowTipsId,
        clearMyProperTips: clearMyProperTips,
        getPropertyLinkUrl: function() {
            return property_jump_url;
        }
    }
});
