/*
个人中心广告位展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage;
    var utils = require('../utils'),
        iapPay = false,
        migrateVip = require('./visitor_trans'),
        appVersion = utils.getAppVersion();

    function initTvSvip() {
        utils.isInreviewVer(function(vertype) {
            if (vertype == "1") { //审核版本，屏蔽入口
                $('.js_tv_svip').hide();
            } else {
                initTvSvipCalbck();
            }
        });
    }

    function initTvSvipCalbck() { //只支持安卓app、iphone 越狱、iphone 绕iap，不支持IAP支付场景
        if (utils.isAndroidPf()) {
            iapPay = false;
            $('.js_tv_svip').show();
        } else {
            utils.getAppInfo(function(json_app) {
                if (json_app.isJBOS == 1) {
                    iapPay = false;
                    $('.js_tv_svip').show();
                } else {
                    utils.getIapType(function(json_iap) {
                        if (json_iap.useh5 == 1 || json_iap.useh5 == 2) {
                            iapPay = false;
                            $('.js_tv_svip').show();
                        } else {
                            iapPay = true;
                            if (utils.versionCompare(appVersion, "5.7.1")) {
                                $('.js_tv_svip').show();
                            } else {
                                $('.js_tv_svip').hide();
                            }
                        }
                    });
                }
            });
        }
        bindEvent();
    }

    function bindEvent() {
        $(document).undelegate('.js_tv_svip', 'click')
            .delegate(".js_tv_svip", "click", function(e) {
                utils.getPayVip(function(json) {
                    if (json && json.result && json.result.code == 0) {
                        if (json.visitor && json.visitor.vip == 1) { //游客会员提示转移
                            utils.isAccountLogin(function(json_account) {
                                var accountType = json_account.type;
                                var data = json_account.userInfo;
                                if ("qq" == accountType) { //qq imgrate
                                    $('.js_svip_visitor_qq').text(['转移VIP到QQ帐号:', data.uin].join(''));
                                    $('.js_svip_visitor_qq').addClass('special_mark');
                                    $('.js_svip_visitor_wx').removeClass('special_mark');
                                    $('.js_svip_visitor_wx').hide();
                                    $('.js_svip_visitor_qq').show();
                                } else if ("wx" == accountType) { //wx imgrate
                                    var nickname = data.nickname;
                                    $('.js_svip_visitor_wx').text(['转移VIP到微信帐号:', nickname].join(''));
                                    $('.js_svip_visitor_wx').addClass('special_mark');
                                    $('.js_svip_visitor_qq').removeClass('special_mark');
                                    $('.js_svip_visitor_wx').show();
                                    $('.js_svip_visitor_qq').hide();
                                }
                                $('.js_ios_svip_visitor_layer').removeClass('none');
                                $('.m_layer_mask').show();
                            }, function() {
                                $('.js_svip_visitor_qq').removeClass('special_mark');
                                $('.js_svip_visitor_wx').removeClass('special_mark');
                                $('.js_svip_visitor_qq').show();
                                $('.js_svip_visitor_wx').show();
                                $('.js_ios_svip_visitor_layer').removeClass('none');
                                $('.m_layer_mask').show();
                            });

                            return false;
                        } else {
                            _goSvipPay($(e.currentTarget));
                            return false;
                        }
                    } else {
                        _goSvipPay($(e.currentTarget));
                        return false;
                    }
                }, function() {
                    _goSvipPay($(e.currentTarget));
                    return false;
                });
            });
        $(document).undelegate('.js_svip_visitor_cancel', 'click')
            .delegate(".js_svip_visitor_cancel", "click", function(e) {
                $('.js_ios_svip_visitor_layer').addClass('none');
                $('.m_layer_mask').hide();
            });
        $(document).undelegate('.js_svip_visitor_qq', 'click')
            .delegate(".js_svip_visitor_qq", "click", function(e) {
                $('.js_ios_svip_visitor_layer').addClass('none');
                $('.m_layer_mask').hide();
                migrateVip.openMigrateVip("qq");
            });
        $(document).undelegate('.js_svip_visitor_wx', 'click')
            .delegate(".js_svip_visitor_wx", "click", function(e) {
                $('.js_ios_svip_visitor_layer').addClass('none');
                $('.m_layer_mask').hide();
                migrateVip.openMigrateVip("wx");
            });

    }

    function _goSvipPay(target) {
        $('.js_ios_svip_visitor_layer').addClass('none');
        $('.m_layer_mask').hide();
        var linkUrl = target.data("tvvipUrl");
        var hottag = target.attr("hottag");
        var ptag = "svip.kt.ipho";
        if (utils.isAndroidPf()) {
            ptag = "svip.kt.apho";
        }
        if (linkUrl) {
            linkUrl += "?ptag=" + ptag;
            if (iapPay) {
                if (linkUrl.indexOf('?') > -1) {
                    linkUrl += '&iapPay=1';
                } else {
                    linkUrl += '?iapPay=1';
                }
            }
            utils.openUrlCommon(linkUrl);
        }

    }

    exports.init = initTvSvip;
});
