/*
个人中心广告位展示
 */
define(function(require, exports, module) {
    var storage = window.localStorage,
        utils = require('../utils'),
        normalizer = require('./urlFactory').createNormalizer(),
        ptagBuilder = require('./ptagBuilder'),
        reportConf_new = require('./report/report_conf'),
        reportConf = reportConf_new.hottagConf,
        reportApi_new = require('./report/client'),
        aidReport = require('./report/aid').init(),
        param = {},
        _s_ad_show = false,
        _a_ad_show = false;

    function initAd(cbk) {
        utils.isInreviewVer(function(vertype) {
            param.vertype = vertype;
            if (vertype == "1") { //审核版本，屏蔽头图
                $('.js_package_ad').hide();
                cbk && cbk();
            } else {
                initAdCalbck(cbk);
            }
        });
    }

    function initSSAd(cbk) {
        utils.isInreviewVer(function(vertype) {
            param.vertype = vertype;
            if (vertype == "1") { //审核版本，屏蔽头图
                param.adLevel = "";
                $('.js_vip_ss_ad').hide();
                cbk && cbk();
            } else {
                initSSAdCalbck(cbk);
            }
        });
    }

    function initSSAdCalbck(cbk) {
        utils.isAccountLogin(function(login_data) {
            var user_data = login_data.userInfo;
            var uin = user_data.uin || "";
            _reqSSAd(true, uin).done(function(hasAd_aLevel) {
                cbk && cbk(hasAd_aLevel);
            });
        }, function() {
            _reqSSAd(false).done(function(hasAd_aLevel) {
                cbk && cbk(hasAd_aLevel);
            });
        });
    }

    function initAdCalbck(cbk) {
        utils.isAccountLogin(function(login_data) {
            var user_data = login_data.userInfo;
            var uin = user_data.uin || "";
            _reqNormalAd(uin).done(function(ad_param) {
                cbk && cbk(ad_param);
            });
        }, function() {
            _reqNormalAd().done(function(ad_param) {
                cbk && cbk(ad_param);
            });
        });
    }

    function _reqSSAd(isLogin, uin) {
        uin = uin || "";
        param.hasAd_aLevel = false;
        var $defer = $.Deferred();
        _getSSLevelAd(isLogin, uin).done(function(res) {
            param.adLevel = "ss";
            _build_SS_Ad(res);
            $defer.resolve(param);
        }).fail(function() {
            param.adLevel = "";
            $('.js_vip_ss_ad').hide();
            $defer.reject();
        });
        return $defer.promise();
    }

    function _reqNormalAd(uin) {
        uin = uin || "";
        var ad_param = {};
        ad_param.hasAd_aLevel = false;
        var $defer = $.Deferred();
        _getHighLevelAd("s", uin).done(function(res) {
            ad_param.adLevel = "s";
            _hideAdDom("s");
            _build_S_Ad(res);
            $defer.resolve(ad_param.hasAd_aLevel);
        }).fail(function() {
            ad_param.adLevel = "a";
            _getAd().done(function(json) {
                if (json.items.length > 0) {
                    ad_param.hasAd_aLevel = true;
                    _hideAdDom("a");
                    _buildAd(json.items);
                    $defer.resolve(ad_param.hasAd_aLevel);
                } else {
                    $('.js_package_ad').hide();
                    $defer.resolve(ad_param.hasAd_aLevel);
                }
            }).fail(function() {
                $('.js_package_ad').hide();
                $defer.resolve(ad_param.hasAd_aLevel);
            });
        });
        return $defer.promise();
    }

    function _hideAdDom(level) {
        if ("s" == level) {
            $('.js_package_ad').hide();
        } else if ("a" == level) {
            $('.js_vip_s_ad').hide();
        }
    }

    function _getAd() {
        var $defer = $.Deferred();
        $.ajax({
            url: normalizer("http://mobile.video.qq.com/fcgi-bin/dout_iphone?otype=json&auto_id=1319&platform=7&version=0"),
            dataType: "jsonp"
        }).done(function(json) {
            if (json && json.returncode == 0) {
                $defer.resolve(json);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function _getHighLevelAd(level, uin) {
        var $defer = $.Deferred();
        var plat = utils.getPlatform();
        var platform_ad = "app_aphone";
        if (plat == 7) {
            platform_ad = "app_iphone";
        }
        uin = uin || "";
        var url = 'http://node.video.qq.com/x/vip/api/common?_m=adv.getAdv("' + platform_ad + '", "' + level + '","' + uin + '")';
        $.ajax({
            url: normalizer(url),
            dataType: "jsonp"
        }).done(function(json) {
            if (json && json.ret == 0 && json.data && json.data.adv && json.data.adv.adv) {
                $defer.resolve(json.data.adv.adv);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function _getSSLevelAd(isLogin, uin) {
        var $defer = $.Deferred();
        _getHighLevelAd("ss", uin).done(function(res) {
            $defer.resolve(res);
            //先不做资格校验
            /*if (!res.actid || !isLogin) {
                $defer.resolve(res);
            } else if (isLogin) {
                _checkJoined(res.actid).done(function(hasJoined) {
                    if (hasJoined) {
                        $defer.resolve(res);
                    } else {
                        $defer.reject();
                    }
                }).fail(function() {
                    $defer.reject();
                });
            } else {
                $defer.resolve(res);
            }*/
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function _checkJoined(actid) {
        var $defer = $.Deferred();
        var url = '//vip.video.qq.com/fcgi-bin/comm_cgi?name=activity_attend_query&cmd=61465&otype=json&yuzhu_id=' + actid;
        $.ajax({
            url: normalizer(url),
            dataType: "jsonp"
        }).done(function(json) {
            if (json && json.ret_code == 0) {
                $defer.resolve(json.exist == 0);
            } else {
                $defer.reject();
            }
        }).fail(function() {
            $defer.reject();
        });
        return $defer.promise();
    }

    function getParamValue(url, name) {
        var reg = new RegExp('(\\?|&)' + name + '=([^&?]*)', 'i');
        var arr = url.match(reg);
        if (arr) {
            return arr[2];
        }
        return null;
    }

    function _getPtagAdd(level) {
        level = level || "a";
        var ptagAdd = "ad.kt.apho";
        if ("s" == level) {
            ptagAdd = "ad_s.kt.apho";
            if (utils.isIosPf()) {
                ptagAdd = "ad_s.kt.ipho";
            }
        } else if ("ss" == level) {
            ptagAdd = "ad_ss.kt.apho";
            if (utils.isIosPf()) {
                ptagAdd = "ad_ss.kt.ipho";
            }
        } else {
            ptagAdd = "ad.kt.apho";
            if (utils.isIosPf()) {
                ptagAdd = "ad.kt.ipho";
            }
        }

        return ptagAdd;
    }


    function _buildAd(items) {
        var plat = utils.getPlatform();
        for (var i = 0; i < items.length; i++) {
            var item = items[i];
            if (plat == item.condition) {
                var link_url = ptagBuilder.addPtag(item.link_url, _getPtagAdd()),
                    reportTag = item.report_tag,
                    ptag = getParamValue(link_url, 'ptag'),
                    reportTag_click = reportTag,
                    hottag = reportConf.openPay_tuiguang,
                    f_module = reportConf_new.getModule(hottag);
                if (ptag) {
                    reportTag_click = [ptag, '.', reportTag].join('');
                    $('.js_package_ad').attr('f_ptag', ptag);
                }
                $('.js_package_ad .js_title').text(item.title);
                if (item.sub_title) {
                    $('.js_package_ad .js_subTitle').text(item.sub_title);
                    $('.js_package_ad .js_subTitle_wrapper').show();
                } else {
                    $('.js_package_ad .js_subTitle_wrapper').hide();
                }
                $('.js_package_ad .js_btn_txt').text(item.btn_txt);
                $('.js_package_ad').attr('data-url', normalizer(link_url));
                $('.js_package_ad').attr('hottag', hottag);
                $('.js_package_ad').attr('f_resource', item.title);
                $('.js_package_ad').attr('f_type', "5");
                if (reportTag) {
                    $('.js_package_ad').attr('f_actid', reportTag);
                }
                $('.js_package_ad').show();
                if (!_a_ad_show) {
                    _a_ad_show = true;
                    reportApi_new.click({ f_aid: aidReport.replace(/\$/g, '|||'), f_actid: reportTag, f_ptag: ptag, f_module: f_module, f_resource: item.title, f_event: "expose", f_hottag: hottag, f_type: 5 });
                }
                break;
            }
        };
    }

    function _build_SS_Ad(ad) {
        if (ad) {
            var mainPic = ad.mainPic,
                url = ptagBuilder.addPtag(ad.url, _getPtagAdd("ss")),
                actid = ad.actid,
                hottag = reportConf.vip_ads_ss,
                pageTage = getParamValue(url, 'ptag'),
                f_module = reportConf_new.getModule(hottag);
            $('.js_vip_ss_ad .js_ss_img').attr("src", mainPic);
            $('.js_vip_ss_ad .js_ss_link').attr("f_module", f_module);
            $('.js_vip_ss_ad .js_ss_img').attr("f_module", f_module);
            $('.js_vip_ss_ad .js_ss_pay').attr("f_module", f_module);
            $('.js_vip_ss_ad .js_ss_link').attr("f_type", "5");
            $('.js_vip_ss_ad .js_ss_img').attr("f_type", "5");
            $('.js_vip_ss_ad .js_ss_pay').attr("f_type", "5");
            if (pageTage) {
                $('.js_vip_ss_ad .js_ss_link').attr("f_ptag", pageTage);
                $('.js_vip_ss_ad .js_ss_img').attr("f_ptag", pageTage);
                $('.js_vip_ss_ad .js_ss_pay').attr("f_ptag", pageTage);
            }
            if (actid) {
                $('.js_vip_ss_ad .js_ss_link').attr("f_actid", actid);
                $('.js_vip_ss_ad .js_ss_img').attr("f_actid", actid);
                $('.js_vip_ss_ad .js_ss_pay').attr("f_actid", actid);
            }
            $(document).undelegate('.js_vip_ss_ad .js_ss_link', 'click')
            $(document).delegate('.js_vip_ss_ad .js_ss_link', 'click', function(event) {
                event.preventDefault();
                utils.openUrlCommon(url);
                $('.js_vip_ss_ad').hide();
                $('.m_layer_mask').hide();
            });
            $(document).undelegate('.js_vip_ss_ad .js_ss_img', 'click')
            $(document).delegate('.js_vip_ss_ad .js_ss_img', 'click', function(event) {
                event.preventDefault();
                utils.openUrlCommon(url);
                $('.js_vip_ss_ad').hide();
                $('.m_layer_mask').hide();
            });
            $(document).undelegate('.m_layer_mask', 'click')
            $(document).delegate('.m_layer_mask', 'click', function(event) {
                event.preventDefault();
                if ($('.js_vip_ss_ad').is(":visible")) {
                    $('.js_vip_ss_ad').hide();
                    $('.m_layer_mask').hide();
                }

            });
        } else {
            $('.js_vip_ss_ad').hide();
            $('.m_layer_mask').hide();
        }
    }

    function _build_S_Ad(ad) {
        if (ad) {
            var mainPic = ad.mainPic,
                url = ptagBuilder.addPtag(ad.url, _getPtagAdd("s")),
                actid = ad.actid,
                hottag = reportConf.vip_ads_s,
                pageTage = getParamValue(url, 'ptag'),
                f_module = reportConf_new.getModule(hottag),
                f_resource = $('.js_vip_s_ad').attr("f_resource");
            if (actid) {
                $('.js_vip_s_ad').attr("f_actid", actid);
            }
            if (pageTage) {
                $('.js_vip_s_ad').attr("f_ptag", pageTage);
            }
            $('.js_vip_s_ad').attr("f_type", "5");
            $('.js_vip_s_ad .js_s_img').attr("src", mainPic);
            $('.js_vip_s_ad').show();
            if (!_s_ad_show) {
                _s_ad_show = true;
                reportApi_new.click({ f_aid: aidReport.replace(/\$/g, '|||'), f_actid: actid, f_ptag: pageTage, f_module: f_module, f_resource: f_resource, f_event: "expose", f_hottag: hottag, f_type: 5 });
            }
            $(document).undelegate('.js_vip_s_ad', 'click')
            $(document).delegate('.js_vip_s_ad', 'click', function(event) {
                utils.openUrlCommon(url);
            });
        } else {
            $('.js_vip_s_ad').hide();
        }
    }

    module.exports = {
        init: initAd,
        initSSAd: initSSAd,
        get_ads_param: function() {
            return param
        },
        showSSAds: function() {
            $('.js_vip_ss_ad').show();
            $('.m_layer_mask').show();
            var actid = $('.js_vip_ss_ad .js_ss_link').attr("f_actid"),
                pagetag = $('.js_vip_ss_ad .js_ss_link').attr("f_ptag"),
                f_module = $('.js_vip_ss_ad .js_ss_link').attr("f_module"),
                f_resource = $('.js_vip_ss_ad .js_ss_link').attr("f_resource");
            reportApi_new.click({ f_aid: aidReport.replace(/\$/g, '|||'), f_actid: actid, f_ptag: pagetag, f_module: f_module, f_resource: f_resource, f_event: "expose", f_hottag: "ad_ss", f_type: 5 });
        }
    }
});
