/**游客转移**/
define(function(require, exports, module) {
    var utils = require('../utils');
    var normalizer = require('./urlFactory').createNormalizer();
    var appVersion = utils.getAppVersion();

    var g_userInfo = null;
    var g_vipInfo = null;
    var _retryTime = 0;
    var _tid = 0;
    var _hasTrasferClick = false;
    var _inreview = 0;

    var TRANS_LOADING_STATUS_START = "blue_star";
    var TRANS_LOADING_STATUS_LOADING = "star_gif";
    var TRANS_LOADING_STATUS_FAILED = "grey_star";

    function _openMigrateTab(userData) {
        utils.isInreviewVer(function(vertype) {
            _inreview = vertype;
            utils.getPayVip(function(vipInfo) {
                if (userData && vipInfo) {
                    g_userInfo = userData;
                    g_vipInfo = vipInfo;
                    _setUserInfo(userData, "js_trans_target");
                    _getVisitorTransTime(vipInfo);
                    if (vipInfo.level && vipInfo.level == 7) {
                        $('.js_crown').show();
                    } else {
                        $('.js_crown').hide();
                    }
                    if (vipInfo.vip == 1 && vipInfo.endTime != "") { //会员
                        $('.js_trans_target .js_endtime').html('<span>有效期:</span><span class="special_mark">' + vipInfo.endTime.substr(0, 10) + '</span>');
                    } else if (vipInfo.endTime != "") { //过期会员
                        $('.js_trans_target .js_endtime').html("您还不是VIP会员");
                    } else { //非会员
                        $('.js_trans_target .js_endtime').html("您的VIP会员已过期");
                    }
                    $('.js_transfering .js_loading_status').addClass(TRANS_LOADING_STATUS_START);
                    $('.js_transfering').show();
                    $('.js_visitor_trans').show();
                    $('.m_layer_mask').show();
                    _bindEvent();
                }

            });
        });

    }

    function openMigrateVip(accountType) {
        $('.js_visitor_trans .js_title').html("确认将游客的VIP服务转移到该账号？");
        utils.isAccountLogin(function(userData) {
            _openMigrateTab(userData)
        }, function() {
            //由于调用app切换帐号jsapi后，退出登录再调用actionlogin有问题（拉不起其中的一个登录框），所以这里使用了switchLoginState拉登录
            utils.switchLoginState(accountType).then(function(msg) {
                //目前switchLoginState米有回调，所以登录回来用户需要再点击一次，回调从5.7.1版本开始支持
                if (msg && msg.errCode == 0 && utils.versionCompare(appVersion, "5.7.1")) {
                    utils.isAccountLogin(function(json_login) {
                        _openMigrateTab(json_login);
                    });
                }
            });
        });
    }

    function _getVisitorTransTime(vipInfo) {
        utils.reqServerTime().done(function(serverTime) {
            _getVisitorTransTimeCk(vipInfo, serverTime);
        }).fail(function() {
            var curTime = Date.now();
            _getVisitorTransTimeCk(vipInfo, curTime);
        });

    }

    function _getVisitorTransTimeCk(vipInfo, curTime) {
        try {
            var endTime = "";
            if (vipInfo.visitor && vipInfo.visitor.vip == 1 && vipInfo.visitor.endTime) {
                var endTimeStr = vipInfo.visitor.endTime;
                endTime = Date.parse(endTimeStr.replace(/-/g, '/'));
                var timeDiff = endTime - curTime;
                if (timeDiff > 0) {
                    var remindDays = parseInt(timeDiff / 86400000);
                    remindDays = timeDiff % 86400000 == 0 ? remindDays : (remindDays + 1);
                    var _transDays = _computeTransDay(remindDays);
                    $('.js_visitor_trans .js_trans_days').html(_transDays);
                } else {
                    $('.js_visitor_trans .js_trans_days').html("");;
                }

            }
        } catch (e) {}
    }

    function _setUserInfo(userData, domTarget) {
        var userInfo = userData.userInfo;
        var defaultFace = "style/app_v/img/user/default_160.png";
        var nick = userInfo.nickname;
        var face = userInfo.headImgUrl ? userInfo.headImgUrl : defaultFace;
        var accountType = userData.type;
        var icon_type = "";
        $('.' + domTarget + ' .js_user_face').attr('src', face);
        $('.' + domTarget + ' .js_nick').html(nick);
        if ("qq" == accountType) {
            icon_type = 'icon_qqr';
        } else if ("wx" == accountType) {
            icon_type = 'icon_weixinr';
        }
        $('.' + domTarget + ' .js_icon').removeClass('icon_qqr').removeClass('icon_weixinr');
        $('.' + domTarget + ' .js_icon').addClass(icon_type);
    }

    function _computeTransDay(transdays) { //转移的天数
        if (transdays > 31) {
            try {
                var month = parseInt(transdays / 31);
                var day = transdays % 31;
                var rtnStr = "";
                if (month > 0) {
                    rtnStr = month + "个月";
                }
                if (day > 0) {
                    rtnStr += day + "天";
                }
                return rtnStr ? rtnStr : (transdays + "天");
            } catch (e) {}
        }
        return transdays + "天";
    }

    function _dateTimeCompare(dateStr1, dateStr2) {
        try {
            var time1 = new Date(Date.parse(dateStr1.replace(/-/g, "/"))).getTime();
            var time2 = new Date(Date.parse(dateStr2.replace(/-/g, "/"))).getTime();
            if (time1 > time2) {
                return true;
            } else {
                return false;
            }
        } catch (e) {}

    }

    function _computeLevleClass(vipInfo) {
        var level = vipInfo.level;
        var className = "";
        if (level > 0) {
            if (vipInfo.vip == 1) { //会员
                className = "vip" + level;
            } else if (vipInfo.endTime != "") { //过期会员
                className = "grey" + level;
            }
        }
        return className;
    }

    function _transFailedPanel() {
        _transformingSet();
        $('.js_visitor_trans .js_title').html("抱歉，本次VIP转移失败，请重试");
        $('.js_transfering .js_transfering_ok').html("重试");
        $('.js_transfering .js_loading_status').addClass(TRANS_LOADING_STATUS_FAILED);
        $('.js_transfering .js_loading_status').removeClass(TRANS_LOADING_STATUS_LOADING);
        $('.js_transfering .js_golden_trans').removeClass('special_mark');
        $('.js_transfering .js_transfering_ok').removeClass("grey_color").addClass('special_mark');
        $('.js_trans_ticket').hide();
        $('.js_trans_givemovie').hide();
        $('.js_trans_score').hide();
        $('.js_trans_ticket .res').html("");
        $('.js_trans_givemovie .res').html("");
        $('.js_trans_score .res').html("");
        $('.js_transfering').show();
    }

    function _transSucPanel(vipInfo) {
        _transformingSet();
        utils.refreshVipInfo(function() {});
        $('.js_visitor_trans .js_title').html("VIP转移成功");
        var levelClass = _computeLevleClass(vipInfo);
        $('.js_trans_suc_target .js_level').addClass(levelClass);
        if (vipInfo.level && vipInfo.level == 7) {
            $('.js_crown').show();
        } else {
            $('.js_crown').hide();
        }
        $('.js_trans_result .js_trans_date').html(vipInfo.endTime.substr(0, 10));
        $('.js_transfer_suc').show();
    }

    function _transformingSet() {
        $('.js_transfering .js_transfering_ok').addClass("special_mark").removeClass('grey_color');
        $('.js_transfering .js_loading_status').addClass(TRANS_LOADING_STATUS_START);
        $('.js_transfering .js_loading_status').removeClass(TRANS_LOADING_STATUS_LOADING);
        $('.js_transfering').hide();

    }

    function _retryPayVip() {
        _tid = setTimeout(function() {
            utils.reqPayVip(function(vipInfo) {
                _retryTime += 1;
                var endTimeNew = vipInfo.endTime;
                var endTimeOld = g_vipInfo.endTime;
                if (vipInfo.visitor && vipInfo.visitor.vip == 1 && _dateTimeCompare(endTimeNew, endTimeOld)) {
                    //仍是游客会员，但会员时长已增加,即转移成功，但回收失败
                    if (_retryTime < 4) {
                        _retryPayVip();
                    } else {
                        _transformingSet();
                        $('.js_visitor_trans .js_title').html("VIP转移成功");
                        var levelClass = _computeLevleClass(vipInfo);
                        $('.js_trans_suc_target .js_level').addClass(levelClass);
                        $('.js_trans_result .js_trans_date').html(vipInfo.endTime.substr(0, 10));
                        $('.js_trans_result .js_trans_delay').show();
                        $('.js_transfer_suc').show();
                        _retryTime = 0;
                        clearTimeout(_tid);
                        _tid = 0;
                    }
                } else if (vipInfo.vip == 1) {
                    _retryTime = 0;
                    clearTimeout(_tid);
                    _tid = 0;
                    _transSucPanel(vipInfo);
                } else {
                    _transFailedPanel();
                    _retryTime = 0;
                    clearTimeout(_tid);
                    _tid = 0;
                }
            });
        }, 2000);
    }

    function _bindEvent() {
        $(document).undelegate(".js_transfering .js_transfering_cancel", "click")
            .delegate(".js_transfering .js_transfering_cancel", "click", function(e) {
                _transformingSet();
                _hasTrasferClick = false;
                $('.m_layer_mask').hide();
                $('.js_visitor_trans').hide();
                $('.js_transfering').hide();
                $('.js_transfer_suc').hide();
            });

        $(document).undelegate('.js_transfering .js_transfering_ok', 'click')
            .delegate(".js_transfering .js_transfering_ok", "click", function(e) {
                if (!_hasTrasferClick) {
                    _hasTrasferClick = true;
                    $('.js_transfering .js_loading_status').removeClass(TRANS_LOADING_STATUS_START);
                    $('.js_transfering .js_loading_status').addClass(TRANS_LOADING_STATUS_LOADING);
                    $('.js_visitor_trans .js_title').html("VIP正在转移中，请稍候");
                    $('.js_transfering .js_transfering_ok').removeClass("special_mark").addClass('grey_color');
                    utils.transVistor2Vip(function(json) {
                        _setUserInfo(g_userInfo, "js_trans_suc_target");
                        var transdays = _computeTransDay(json.transferdays);
                        var ticket = json.movietikets;
                        var score = json.vipscore;
                        var givemovie = json.givemovieright;
                        $('.js_trans_result .js_trans_days').html(transdays);

                        setTimeout(function() {
                            _hasTrasferClick = false;
                            utils.reqPayVip(function(vipInfo) {
                                var endTimeNew = vipInfo.endTime;
                                var endTimeOld = g_vipInfo.endTime;
                                if (vipInfo.visitor && vipInfo.visitor.vip == 1 && _dateTimeCompare(endTimeNew, endTimeOld)) {
                                    //仍是游客会员，但会员时长已增加,即转移成功，但回收失败
                                    _retryPayVip();
                                } else if (vipInfo.vip == 1 && _dateTimeCompare(endTimeNew, endTimeOld)) {
                                    if (ticket > 0 && !_inreview) {
                                        $('.js_trans_ticket .res').html("+" + ticket);
                                        $('.js_trans_ticket').show();
                                    } else if (_inreview) {
                                        $('.js_trans_ticket').hide();
                                    }
                                    if (score > 0 && !_inreview) {
                                        $('.js_trans_score .res').html("+" + score);
                                        $('.js_trans_score').show();
                                    } else if (_inreview) {
                                        $('.js_trans_score').hide();
                                    }
                                    if (givemovie > 0 && !_inreview) {
                                        $('.js_trans_givemovie .res').html("+" + givemovie);
                                        $('.js_trans_givemovie').show();
                                    } else if (_inreview) {
                                        $('.js_trans_givemovie').hide();
                                    }
                                    _transSucPanel(vipInfo);
                                } else {
                                    _transFailedPanel();
                                }
                            }, function() {
                                _transFailedPanel();
                            });
                        }, 2000);


                    }, function() {
                        _hasTrasferClick = false;
                        _transFailedPanel();
                    });
                }


            });
        $(document).undelegate(".js_transfer_suc .js_transfered_ok", "click")
            .delegate(".js_transfer_suc .js_transfered_ok", "click", function(e) {
                $('.m_layer_mask').hide();
                $('.js_visitor_trans').hide();
                $('.js_transfering').hide();
                $('.js_transfer_suc').hide();
            });
    }

    module.exports = {
        openMigrateVip: openMigrateVip
    };
});
